﻿Imports System.ComponentModel
Imports System.Windows.Forms
Imports DGVSetColumns.dtsDGVSetColumns

Public Class frmDGVSetColumns
	Private _StopWatch As New Diagnostics.Stopwatch

	Public Sub New()
		InitializeComponent()
		If NotifyPropertyChanged.IsInDesignMode Then Return
		ControlStyling.StyleControls(Me)
		Dts.DataFile("..\..\DataStuff\dtsDGVSetColumns.xml").Register(Me) '.Fill
		GenerateData()
		AutoMenu.Create(AddressOf MyAllCellsExceptHeader, AddressOf Test2, AddressOf GenerateData)("Fill", AddressOf Dts.Fill)("Save", AddressOf Dts.Save)("Clear", AddressOf Dts.Clear).Nop
		cmbSizeMode.DataSource = EnumGetValues(DataGridViewAutoSizeColumnsMode.None)
	End Sub

	Private Sub GenerateData()
		_StopWatch.Restart()
		Dim data = "x yy uuu eeeee aaaaaaaaaaaaa zzzx yy uuu eeeee aaaaaaaaaaaaa zzz".Split.GetEnumeratorX
		For i = 9999 To 0 Step -1
			With data
				Dts.DataTable1.AddDataTable1Row(.YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i, .YieldCyclic & i)
			End With
		Next
		LogDuration("GenerateData")
	End Sub

	Private Sub MyAllCellsExceptHeader()
		If dgvDataTable1.AutoSizeColumnsMode <> DataGridViewAutoSizeColumnsMode.None Then
			cmbSizeMode.SelectedIndex = 0
			cmbSizeMode_DropDownClosed(Nothing, Nothing)
		End If
		_StopWatch.Restart()
		AllCellsExceptHeader(dgvDataTable1)
		LogDuration("MyAllCellsExceptHeader")
	End Sub

	Private Sub AllCellsExceptHeader(dgv As DataGridView)
		'Durchläuft für jede Spalte alle zeilen und sucht die sechs längsten Texte. Nur diese werden ausgemessen, und das Maximum als ColumnWidth gesetzt
		'Annahme: alle Zellen der Spalte haben denselben Font. Keine Image-Cells.
		'Zuschläge müsste man noch einführen Für Button- oder Combobox-Columns, sowie für GridLines, und vmtl. noch weiteren Schnickschnack.
		Dim fillingCols = dgv.Columns.Cast(Of DataGridViewColumn).ToLookup(Function(c) c.AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill)
		fillingCols(True).ForEach(Sub(c) c.AutoSizeMode = DataGridViewAutoSizeColumnMode.None) ' alle AutoSize.Fill deaktivieren
		For Each col In fillingCols(False) ' alle Columns mit AutoSizeMode <> Fill 
			Dim q = New Queue(Of String)("      ".Split) '6 mal ""
			Dim maxLen = 0
			Dim x = col.Index
			For y = 0 To dgv.Rows.Count - 1
				Dim s = dgv(x, y).FormattedValue.ToString
				If s.Length > maxLen Then
					q.Dequeue()
					q.Enqueue(s)
					maxLen = s.Length
				End If
			Next
			col.Width = q.Max(Function(s) TextRenderer.MeasureText(s, col.DefaultCellStyle.Font).Width)
		Next
		fillingCols(True).ForEach(Sub(c) c.AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill) ' alle AutoSize.Fill reaktivieren
	End Sub

	Private Sub Test2()
	End Sub

	Private Sub cmbSizeMode_DropDownClosed(sender As Object, e As EventArgs) Handles cmbSizeMode.DropDownClosed
		_StopWatch.Restart()
		dgvDataTable1.AutoSizeColumnsMode.Be(cmbSizeMode.SelectedItem)
		LogDuration($"SizeMode.{cmbSizeMode.SelectedItem}")
	End Sub

	Private Sub LogDuration(text As String)
		_StopWatch.Stop()
		Dim s = $"{text & ": " & _StopWatch.ElapsedMilliseconds \ 1000 & "s",40}"
		lstLog.Items.Add(s)
	End Sub
End Class