﻿
Namespace System.ComponentModel
   Public Class DelegatePropertyDescriptor
      Inherits PropertyDescriptor
      Private _GetName As Func(Of String)
      Private _GetValue As Func(Of Object)
      Public Sub New(getName As Func(Of String), getValue As Func(Of Object))
         MyBase.New(getName(), Nothing)
         If getName Is Nothing OrElse getValue Is Nothing Then
            Throw New ArgumentNullException()
         End If
         _GetName = getName
         _GetValue = getValue
      End Sub
      Public Overrides ReadOnly Property IsReadOnly() As Boolean
         Get
            Return True
         End Get
      End Property
      Public Overrides Function CanResetValue(component As Object) As Boolean
         Return False
      End Function
      Public Overrides ReadOnly Property ComponentType() As Type
         Get
            Throw New NotImplementedException()
         End Get
      End Property
      Public Overrides Function GetValue(component As Object) As Object
         Return _GetValue()
      End Function
      Public Overrides ReadOnly Property Name() As String
         Get
            Return _GetName()
         End Get
      End Property
      Public Overrides ReadOnly Property PropertyType() As Type
         Get
            Return _GetValue().[GetType]()
         End Get
      End Property
      Public Overrides Sub ResetValue(component As Object)
         Throw New NotImplementedException()
      End Sub
      Public Overrides Sub SetValue(component As Object, value As Object)
         Throw New NotImplementedException()
      End Sub
      Public Overrides Function ShouldSerializeValue(component As Object) As Boolean
         Return False
      End Function
   End Class

End Namespace
