
#Region "FileHeader"
#If False Then
jdkwei
#End If '-- Options, Imports
#End Region 'FileHeader


Imports System
Imports System.Diagnostics
Imports System.Runtime.CompilerServices

Namespace System

   Public Class NotifyEventArgs
      Public Shared Function Create(Of T)(value As T) As NotifyEventArgs(Of T)
         Return New NotifyEventArgs(Of T)(value)
      End Function
      Public Shared Function Create(ParamArray values As Object()) As NotifyEventArgs(Of String)
         Return New NotifyEventArgs(Of String)(String.Concat(values))
      End Function
   End Class
   Public Class NotifyEventArgs(Of T) : Inherits EventArgs
      Public ReadOnly Value As T
      Public Sub New(Value As T)
         MyBase.New()
         Me.Value = Value
      End Sub
   End Class 'NotifyEventArgs(Of T)

   Public Delegate Sub EventHandlerEx(Of T0, T1 As EventArgs)(Sender As T0, e As T1)

   Public Delegate Sub EventHandlerEx(Of T0)(Sender As T0)

   Public Module modHelpers

      Public DebugDummi As Object
      Private _DbgID As Integer

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(Args As System.Collections.IEnumerable)
#If Not Debug Then
         Return
#End If
         Dim Args2 As New List(Of Object)
         Args2.Add(_DbgID)
         _DbgID = (_DbgID + 1) Mod 10
         For Each arg In Args
            Args2.Add(" ")
            Args2.Add(arg)
         Next
         Debug.WriteLine(String.Concat(Args2))
      End Sub

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(Args As IList(Of Object))
#If Not Debug Then
         Return
#End If
         Dim Args2(Args.Count * 2) As Object
         Args2(0) = _DbgID & " "
         _DbgID = (_DbgID + 1) Mod 10
         For i As Integer = 0 To Args.Count - 1
            Args2(i * 2 + 1) = If(Args(i), "##-Null-##")
            Args2(i * 2 + 2) = " "
         Next
         Debug.WriteLine(String.Concat(Args2))
      End Sub

      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub DbgCaller(<CallerMemberName> Optional caller As String = Nothing)
         Dbg(caller)
      End Sub
      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(ParamArray Args As Object())
         Dbg(DirectCast(Args, IList(Of Object)))
      End Sub
      ''' <summary>einfache Debug-Ausgabe, nimmt alles, unkaputtbar</summary>
      Public Sub Dbg(s As String)
#If Not Debug Then
         Return
#End If
         Debug.WriteLine(String.Concat(_DbgID, " ", s))
         _DbgID = (_DbgID + 1) Mod 10
      End Sub

      ''' <summary>Debug-Ausgabe, erweiterte Formatierung akzeptierend - siehe String.FormatX - Extension</summary>
      Public Sub DbgFormat(format As String, ParamArray Args() As Object)
#If Not Debug Then
         Return
#End If
         Debug.WriteLine(format.FormatX(Args))
      End Sub

      Private _Args(-1) As Object
      ''' <summary> macht nur dann eine Ausgabe, wenn die Werte sich zwischenzeitlich gendert haben </summary>
      Public Sub DbgChanges(ParamArray Args As Object())
         If Enumerable.SequenceEqual(Args, _Args) Then Return
         _Args = Args
         Dbg(DirectCast(Args, IList(Of Object)))
      End Sub

      ''' <summary> Quick and Dirty - Messagebox (aber das ist Messagebox ja immer) </summary>
      Public Function Msg(msg1 As Object, ParamArray msgs() As Object) As Microsoft.VisualBasic.MsgBoxResult
         Dim strings = {msg1}.Concat(msgs).Select(Function(o) ReplaceBslashN(o.ToString))
         Dim s = String.Concat(strings)
         Return Microsoft.VisualBasic.MsgBox(s)
      End Function

   End Module


End Namespace
