﻿#Region "FileHeader"
#If False Then
DataParser holds a sorted array of String-Entries. Parses arbitrary strings to figures out, which Entries match best, from what position on the matches diverge, and what the next valid input-keys are.
theory: assume entries:
angry
another
anotation
anything
Then the input "ano" lies in a "MatchRange" of "anot", in the lines #2, #3.
The MatchRangeWidth is 4, although the inputs length is only 3.
The MatchRangeWidth gives a preview, how the input will continue whithout alternatives.
in other direction the ParentMatchRange is "an", in all lines (#1-#4).
MatchRangeWidth and ParentMatchRangeWidth are Informations needed by Completion-Behavior. If WindForward-Behavior is enabled, the autocompletion-Selection winds forward to MatchRangeWidth or backwards to ParentMatchRangeWidth, in order to reduce the users key-strokes to the indispensable ones.
#End If '-- Options, Imports
#End Region 'FileHeader

Namespace System.Windows.Forms

   Partial Class CompletionPreviewBase

      Public Class DataParser

         Public FirstBestMatch As String
         Public ValidInputLength, MatchRangeWidth, ParentMatchRangeWidth As Integer

         Private _FirstMatchPos, _LastMatchPos As Integer
         Public RawWords As Array

         'figure out _FirstMatchPos, _LastMatchPos, FirstbestMatch, ValidInputLength, MatchRangeWidth, ParentMatchRangeWidth
         Public Sub Parse(txt As String)
            _FirstMatchPos = FindBestMatch(txt) ' first cut - possibly incorrect, on invalid input
            FirstBestMatch = Words(_FirstMatchPos)
            ValidInputLength = GetDivergence(txt, FirstBestMatch, 0)
            If ValidInputLength < txt.Length Then 'signals invalid input
               'depending on the sort-order of the first invalid char FindBestMatch() may have retrieved the position **after** the option-range
               Dim div2 = If(_FirstMatchPos = 0, -1, GetDivergence(txt, Words(_FirstMatchPos - 1), 0))
               If div2 < ValidInputLength Then
                  _LastMatchPos = FindBestMatch(txt.Substring(0, ValidInputLength) & Char.MaxValue) - 1
               Else
                  '_FirstMatchPos actually incorrect, and contains the position, _LastMatchPos should have. Make up that fault
                  _LastMatchPos = _FirstMatchPos - 1
                  ValidInputLength = div2
                  _FirstMatchPos = FindBestMatch(txt.Substring(0, ValidInputLength))
                  FirstBestMatch = Words(_FirstMatchPos)
               End If
            Else
               _LastMatchPos = FindBestMatch(txt & Char.MaxValue) - 1 'Position of the last word which fits to ValidInputLength
            End If
            MatchRangeWidth = GetDivergence(FirstBestMatch, Words(_LastMatchPos), ValidInputLength)
            ParentMatchRangeWidth = 0
            If _FirstMatchPos > 0 Then ParentMatchRangeWidth.Maximize(GetDivergence(Words(_FirstMatchPos - 1), FirstBestMatch, 0))
            If _LastMatchPos < RawWords.Length - 1 Then ParentMatchRangeWidth.Maximize(GetDivergence(FirstBestMatch, Words(_LastMatchPos + 1), 0))
         End Sub

         Public Function GetValidKeys(column As Integer) As String
            'only on SelectionStart = _DecisionColumn several Chars are available.
            If column < MatchRangeWidth Then Return FirstBestMatch(column)
            Dim avChars As New List(Of Char)
            Dim c = Char.MinValue
            'loop the option-range and collect the chars at _DecisionColumn distinct
            For i = _FirstMatchPos + Convert.ToInt32(column = FirstBestMatch.Length) To _LastMatchPos
               If Char.ToUpper(Words(i)(MatchRangeWidth)) <> c Then
                  c = Words(i)(MatchRangeWidth)
                  avChars.Add(c)
                  c = Char.ToUpper(c)
               End If
            Next
            Return String.Concat(avChars)
         End Function

         Private Function Words(pos As Integer) As String
            Return DirectCast(RawWords.GetValue(pos), String)
         End Function

         Private Function GetDivergence(s0 As String, s1 As String, start As Integer) As Integer
            GetDivergence = Math.Min(s0.Length, s1.Length)
            For i = start To GetDivergence - 1
               If Char.ToUpper(s0(i)) <> Char.ToUpper(s1(i)) Then Return i
            Next
         End Function

         Private Function FindBestMatch(txt As String) As Integer
            Dim i = Array.BinarySearch(RawWords, txt, StringComparer.OrdinalIgnoreCase)
            Return If(i < 0, Not i, i)
         End Function

      End Class

   End Class
End Namespace
